<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<% 
/////////////////////////////////////////////////////////////////////////////
//                                UserCheck.aspx
//                            -------------------
//   begin                : Thur, June 14, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: UserCheck.aspx,v 1.0.0.0 R1
//   Function: User Check file standard dyndns.org format.
//  
//   Possible Return Values: okuser
//                           baduser
//                           911
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;

//MINTDNSLib.DNSMANClass sd = new MINTDNSLib.DNSMANClass();
SqlConnection Conn = new SqlConnection(ConfigurationSettings.AppSettings["DBCon"]);
Conn.Open();
   //Decode user name and password 
   String AuthString = "";
   String UserID = "";
   String Password = "";
   String InUString = Request.ServerVariables["HTTP_Authorization"];
   if ((InUString == null) || (InUString == "")) {
       Response.Status = "401 Not Authorized";
       Response.AddHeader("WWW-Authenticate", "Basic realm=DDNS");
       Conn.Close();
       Conn.Dispose(); 
       Response.End();
     }
   else { 
   if (InUString.Substring(0, 5) == "Basic"){AuthString = InUString.Substring(6);}
   if ((AuthString != null) && (AuthString != ""))   {
       AuthString = base64_decode(AuthString);
       string[] User_N_Pass = AuthString.Split(':');
       UserID = User_N_Pass.GetValue(0).ToString().Trim().ToLower();
       Password = User_N_Pass.GetValue(1).ToString().Trim();
   }
   else   {
       Conn.Close();
       Conn.Dispose(); 
       Response.Write("911");
       Response.End();
   }        
      }
      //End decode user name and password 

        
      if ((CharCheck(UserID) == false) || (CharCheck(Password) == false)) {
          Conn.Close();
          Conn.Dispose(); 
          Response.Write("911");
          Response.End();
      }



      SqlCommand Ulook = new SqlCommand("CL_User_Check @UserID= '" + UserID + "', @Password='" + base64_encode(Password) + "'", Conn);
      SqlDataReader UlookSet = Ulook.ExecuteReader();
    if (UlookSet.HasRows == false)
    {
        Response.Write("nouser");
    }
    else { Response.Write("okuser"); }
    UlookSet.Close();
    Ulook.Dispose();
    Conn.Close();
    Conn.Dispose();  
    
    

    
    
    
    
 %>
 <script runat="server">
    //Validate input + cross site scriptng block.
     bool CharCheck(string input)
        {
            if ((input == null) || (input == "")) { return false; }
         if (input.Length >= 255){ return false; }
            int nChar;
            input = input.ToLower();
            foreach (char i in input)
               {
                nChar = Convert.ToInt32(i);
               
                if ((nChar > 41 && nChar < 59) || (nChar > 63 && nChar < 123) || (nChar > 31 && nChar < 33))
                { }
                else
                { return false; }
                }
                return true;
       }

string base64_encode(string data){
  
       if ((data == null) || (data == "")) { return ""; }  
     try   
        {    
      byte[] encData_byte = new byte[data.Length];  
      encData_byte = System.Text.Encoding.UTF8.GetBytes(data);  
      string encodedData = Convert.ToBase64String(encData_byte); 
      return encodedData;
        }    
  catch(Exception e) {return e.ToString();}
  }

string base64_decode(string data){

       if ((data == null) || (data == "")) { return ""; }
    try
       {
        System.Text.UTF8Encoding encoder = new System.Text.UTF8Encoding();
        System.Text.Decoder utf8Decode = encoder.GetDecoder();
        byte[] todecode_byte = Convert.FromBase64String(data);
        int charCount = utf8Decode.GetCharCount(todecode_byte, 0, todecode_byte.Length);
        char[] decoded_char = new char[charCount];
        utf8Decode.GetChars(todecode_byte, 0, todecode_byte.Length, decoded_char, 0);
        string result = new String(decoded_char);
        return result;
    }
    catch(Exception e){return e.ToString();}
  }

    
</script>
